﻿''
'' ConsoleVB
''
'' Copyright (c) 2016 http://www.curict.com
'' This software is released under the MIT License, see LICENSE.txt.
''

Module Module1

    Sub Main()
        ' 丸め
        Round()

        ' 切り捨て
        TruncateFloor()

        ' 切り上げ
        Ceiling()

        Console.ReadLine()
    End Sub


    ''' <summary>
    ''' 丸め
    ''' </summary>
    Sub Round()
        ' 最近接偶数への丸め(銀行家の丸め・JIS丸め) 
        Console.WriteLine("最近接偶数への丸め(銀行家の丸め・JIS丸め)  ")
        Dim result01 As Double = Math.Round(0.5) ' 0
        Dim result02 As Double = Math.Round(1.5) ' 2
        Dim result03 As Double = Math.Round(2.5) ' 2
        Dim result04 As Double = Math.Round(3.5) ' 4
        Console.WriteLine("Math.Round(0.5, 1)) = " + result01.ToString())
        Console.WriteLine("Math.Round(1.5, 1)) = " + result02.ToString())
        Console.WriteLine("Math.Round(2.5, 1)) = " + result03.ToString())
        Console.WriteLine("Math.Round(3.5, 1)) = " + result04.ToString())

        ' 小数部の桁数を指定した最近接偶数への丸め(銀行家の丸め・JIS丸め) 
        Console.WriteLine("小数部の桁数を指定した最近接偶数への丸め(銀行家の丸め・JIS丸め) ")
        Dim result11 As Double = Math.Round(0.05, 1) ' 0
        Dim result12 As Double = Math.Round(0.15, 1) ' 0.2
        Dim result13 As Double = Math.Round(0.25, 1) ' 0.2
        Dim result14 As Double = Math.Round(0.35, 1) ' 0.4
        Console.WriteLine("Math.Round(0.05, 1)) = " + result11.ToString())
        Console.WriteLine("Math.Round(0.15, 1)) = " + result12.ToString())
        Console.WriteLine("Math.Round(0.25, 1)) = " + result13.ToString())
        Console.WriteLine("Math.Round(0.35, 1)) = " + result14.ToString())

        ' 四捨五入
        Console.WriteLine("四捨五入")
        Dim result21 As Double = Math.Round(0.5, MidpointRounding.AwayFromZero) ' 1
        Dim result22 As Double = Math.Round(1.5, MidpointRounding.AwayFromZero) ' 2
        Dim result23 As Double = Math.Round(2.5, MidpointRounding.AwayFromZero) ' 3
        Dim result24 As Double = Math.Round(3.5, MidpointRounding.AwayFromZero) ' 4
        Console.WriteLine("Math.Round(0.5, MidpointRounding.AwayFromZero)) = " + result21.ToString())
        Console.WriteLine("Math.Round(1.5, MidpointRounding.AwayFromZero)) = " + result22.ToString())
        Console.WriteLine("Math.Round(2.5, MidpointRounding.AwayFromZero)) = " + result23.ToString())
        Console.WriteLine("Math.Round(3.5, MidpointRounding.AwayFromZero)) = " + result24.ToString())

        ' 小数部の桁数を指定した四捨五入
        Console.WriteLine("小数部の桁数を指定した四捨五入")
        Dim result31 As Double = Math.Round(0.05, 1, MidpointRounding.AwayFromZero) ' 0.1
        Dim result32 As Double = Math.Round(0.15, 1, MidpointRounding.AwayFromZero) ' 0.2
        Dim result33 As Double = Math.Round(0.25, 1, MidpointRounding.AwayFromZero) ' 0.3
        Dim result34 As Double = Math.Round(0.35, 1, MidpointRounding.AwayFromZero) ' 0.4
        Console.WriteLine("Math.Round(0.05, , MidpointRounding.AwayFromZero1)) = " + result31.ToString())
        Console.WriteLine("Math.Round(0.15, 1, MidpointRounding.AwayFromZero)) = " + result32.ToString())
        Console.WriteLine("Math.Round(0.25, 1, MidpointRounding.AwayFromZero)) = " + result33.ToString())
        Console.WriteLine("Math.Round(0.35, 1, MidpointRounding.AwayFromZero)) = " + result34.ToString())
    End Sub

    ''' <summary>
    ''' 切り捨て
    ''' </summary>
    Sub TruncateFloor()
        ' 切り捨て(Math.Truncate) 
        Console.WriteLine("切り捨て(Math.Truncate) ")
        Dim result01 As Double = Math.Truncate(0.1) ' 0
        Dim result02 As Double = Math.Truncate(0.9) ' 0
        Dim result03 As Double = Math.Truncate(1.1) ' 1
        Dim result04 As Double = Math.Truncate(1.9) ' 1
        Dim result11 As Double = Math.Truncate(-0.1) ' 0
        Dim result12 As Double = Math.Truncate(-0.9) ' 0
        Dim result13 As Double = Math.Truncate(-1.1) ' -1
        Dim result14 As Double = Math.Truncate(-1.9) ' -1
        Console.WriteLine("Math.Truncate(0.1)) = " + result01.ToString())
        Console.WriteLine("Math.Truncate(0.9)) = " + result02.ToString())
        Console.WriteLine("Math.Truncate(1.1)) = " + result03.ToString())
        Console.WriteLine("Math.Truncate(1.9)) = " + result04.ToString())
        Console.WriteLine("Math.Truncate(-0.1)) = " + result11.ToString())
        Console.WriteLine("Math.Truncate(-0.9)) = " + result12.ToString())
        Console.WriteLine("Math.Truncate(-1.1)) = " + result13.ToString())
        Console.WriteLine("Math.Truncate(-1.9)) = " + result14.ToString())

        ' 小数部の桁数を指定した切り捨て(Math.Truncate) 
        Console.WriteLine("小数部の桁数を指定した切り捨て(Math.Truncate) ")
        Dim result21 As Double = Math.Truncate(0.1234 * (10 ^ 1)) / (10 ^ 1) ' 0.1
        Dim result22 As Double = Math.Truncate(0.1234 * (10 ^ 2)) / (10 ^ 2) ' 0.12
        Dim result23 As Double = Math.Truncate(0.1234 * (10 ^ 3)) / (10 ^ 3) ' 0.123
        Dim result31 As Double = Math.Truncate(-0.1234 * (10 ^ 1)) / (10 ^ 1) ' -0.1
        Dim result32 As Double = Math.Truncate(-0.1234 * (10 ^ 2)) / (10 ^ 2) ' -0.12
        Dim result33 As Double = Math.Truncate(-0.1234 * (10 ^ 3)) / (10 ^ 3) ' -0.123
        Console.WriteLine("Math.Truncate(0.1234 * (10 ^ 1)) / (10 ^ 1) = " + result21.ToString())
        Console.WriteLine("Math.Truncate(0.1234 * (10 ^ 2)) / (10 ^ 2) = " + result22.ToString())
        Console.WriteLine("Math.Truncate(0.1234 * (10 ^ 3)) / (10 ^ 3) = " + result23.ToString())
        Console.WriteLine("Math.Truncate(-0.1234 * (10 ^ 1)) / (10 ^ 1) = " + result31.ToString())
        Console.WriteLine("Math.Truncate(-0.1234 * (10 ^ 2)) / (10 ^ 2) = " + result32.ToString())
        Console.WriteLine("Math.Truncate(-0.1234 * (10 ^ 3)) / (10 ^ 3) = " + result33.ToString())

        ' 切り捨て(Math.Floor) 
        Console.WriteLine("切り捨て(Math.Floor) ")
        Dim result41 As Double = Math.Floor(0.1) ' 0
        Dim result42 As Double = Math.Floor(0.9) ' 0
        Dim result43 As Double = Math.Floor(1.1) ' 1
        Dim result44 As Double = Math.Floor(1.9) ' 1
        Dim result51 As Double = Math.Floor(-0.1) ' -1
        Dim result52 As Double = Math.Floor(-0.9) ' -1
        Dim result53 As Double = Math.Floor(-1.1) ' -2
        Dim result54 As Double = Math.Floor(-1.9) ' -2
        Console.WriteLine("Math.Floor(0.1)) = " + result41.ToString())
        Console.WriteLine("Math.Floor(0.9)) = " + result42.ToString())
        Console.WriteLine("Math.Floor(1.1)) = " + result43.ToString())
        Console.WriteLine("Math.Floor(1.9)) = " + result44.ToString())
        Console.WriteLine("Math.Floor(-0.1)) = " + result51.ToString())
        Console.WriteLine("Math.Floor(-0.9)) = " + result52.ToString())
        Console.WriteLine("Math.Floor(-1.1)) = " + result53.ToString())
        Console.WriteLine("Math.Floor(-1.9)) = " + result54.ToString())

        ' 小数部の桁数を指定した切り捨て(Math.Floor) 
        Console.WriteLine("小数部の桁数を指定した切り捨て(Math.Floor) ")
        Dim result61 As Double = Math.Floor(0.1234 * (10 ^ 1)) / (10 ^ 1) ' 0.1
        Dim result62 As Double = Math.Floor(0.1234 * (10 ^ 2)) / (10 ^ 2) ' 0.12
        Dim result63 As Double = Math.Floor(0.1234 * (10 ^ 3)) / (10 ^ 3) ' 0.123
        Dim result71 As Double = Math.Floor(-0.1234 * (10 ^ 1)) / (10 ^ 1) ' -0.2
        Dim result72 As Double = Math.Floor(-0.1234 * (10 ^ 2)) / (10 ^ 2) ' -0.13
        Dim result73 As Double = Math.Floor(-0.1234 * (10 ^ 3)) / (10 ^ 3) ' -0.124
        Console.WriteLine("Math.Floor(0.1234 * (10 ^ 1)) / (10 ^ 1) = " + result51.ToString())
        Console.WriteLine("Math.Floor(0.1234 * (10 ^ 2)) / (10 ^ 2) = " + result52.ToString())
        Console.WriteLine("Math.Floor(0.1234 * (10 ^ 3)) / (10 ^ 3) = " + result53.ToString())
        Console.WriteLine("Math.Floor(-0.1234 * (10 ^ 1)) / (10 ^ 1) = " + result61.ToString())
        Console.WriteLine("Math.Floor(-0.1234 * (10 ^ 2)) / (10 ^ 2) = " + result62.ToString())
        Console.WriteLine("Math.Floor(-0.1234 * (10 ^ 3)) / (10 ^ 3) = " + result63.ToString())
    End Sub

    ''' <summary>
    ''' 切り上げ
    ''' </summary>
    Sub Ceiling()
        ' 切り上げ
        Console.WriteLine("切り上げ")
        Dim result01 As Double = Math.Ceiling(0.1) ' 1
        Dim result02 As Double = Math.Ceiling(0.9) ' 1
        Dim result03 As Double = Math.Ceiling(1.1) ' 2
        Dim result04 As Double = Math.Ceiling(1.9) ' 2
        Console.WriteLine("Math.Ceiling(0.1)) = " + result01.ToString())
        Console.WriteLine("Math.Ceiling(0.9)) = " + result02.ToString())
        Console.WriteLine("Math.Ceiling(1.1)) = " + result03.ToString())
        Console.WriteLine("Math.Ceiling(1.9)) = " + result04.ToString())

        ' マイナス値の切り上げ(0に寄せる)
        Console.WriteLine("マイナス値の切り上げ(0に寄せる)")
        Dim result11 As Double = Math.Ceiling(-0.1) ' 0
        Dim result12 As Double = Math.Ceiling(-0.9) ' 0
        Dim result13 As Double = Math.Ceiling(-1.1) ' -1
        Dim result14 As Double = Math.Ceiling(-1.9) ' -1
        Console.WriteLine("Math.Ceiling(-0.1)) = " + result11.ToString())
        Console.WriteLine("Math.Ceiling(-0.9)) = " + result12.ToString())
        Console.WriteLine("Math.Ceiling(-1.1)) = " + result13.ToString())
        Console.WriteLine("Math.Ceiling(-1.9)) = " + result14.ToString())

        ' マイナス値の切り上げ(0から遠ざける)
        Console.WriteLine("マイナス値の切り上げ(0から遠ざける)")
        Dim result21 As Double = Math.Floor(-0.1) ' -1
        Dim result22 As Double = Math.Floor(-0.9) ' -1
        Dim result23 As Double = Math.Floor(-1.1) ' -2
        Dim result24 As Double = Math.Floor(-1.9) ' -2
        Console.WriteLine("Math.Floor(-0.1)) = " + result21.ToString())
        Console.WriteLine("Math.Floor(-0.9)) = " + result22.ToString())
        Console.WriteLine("Math.Floor(-1.1)) = " + result23.ToString())
        Console.WriteLine("Math.Floor(-1.9)) = " + result24.ToString())

        ' 小数部の桁数を指定した切り上げ
        Console.WriteLine("小数部の桁数を指定した切り上げ")
        Dim result31 As Double = Math.Ceiling(0.1234 * (10 ^ 1)) / (10 ^ 1) ' 0.2
        Dim result32 As Double = Math.Ceiling(0.1234 * (10 ^ 2)) / (10 ^ 2) ' 0.13
        Dim result33 As Double = Math.Ceiling(0.1234 * (10 ^ 3)) / (10 ^ 3) ' 0.124
        Dim result41 As Double = Math.Floor(-0.1234 * (10 ^ 1)) / (10 ^ 1) ' -0.2
        Dim result42 As Double = Math.Floor(-0.1234 * (10 ^ 2)) / (10 ^ 2) ' -0.13
        Dim result43 As Double = Math.Floor(-0.1234 * (10 ^ 3)) / (10 ^ 3) ' -0.124
        Console.WriteLine("Math.Ceiling(0.1234 * (10 ^ 1)) / (10 ^ 1) = " + result31.ToString())
        Console.WriteLine("Math.Ceiling(0.1234 * (10 ^ 2)) / (10 ^ 2) = " + result32.ToString())
        Console.WriteLine("Math.Ceiling(0.1234 * (10 ^ 3)) / (10 ^ 3) = " + result33.ToString())
        Console.WriteLine("Math.Floor(-0.1234 * (10 ^ 1)) / (10 ^ 1) = " + result41.ToString())
        Console.WriteLine("Math.Floor(-0.1234 * (10 ^ 2)) / (10 ^ 2) = " + result42.ToString())
        Console.WriteLine("Math.Floor(-0.1234 * (10 ^ 3)) / (10 ^ 3) = " + result43.ToString())
    End Sub

    ''' <summary>
    ''' 小数部の桁数を指定した切り捨て
    ''' </summary>
    ''' <param name="value">切り捨て対象の10進数</param>
    ''' <param name="digits">戻り値の少数部の桁数</param>
    ''' <returns>切り捨て結果</returns>
    Function Truncate(value As Double, digits As Integer) As Double
        Dim powValue As Double = (10 ^ digits)
        Return Math.Truncate(value * powValue) / powValue
    End Function

    ''' <summary>
    ''' 小数部の桁数を指定した切り上げ
    ''' </summary>
    ''' <param name="value">切り上げ対象の10進数</param>
    ''' <param name="digits">戻り値の少数部の桁数</param>
    ''' <returns>切り上げ結果</returns>
    Function Ceiling(value As Double, digits As Integer) As Double
        Dim powValue As Double = (10 ^ digits)
        If (value >= 0) Then
            Return Math.Ceiling(value * powValue) / powValue
        Else
            Return Math.Floor(value * powValue) / powValue
        End If
    End Function

End Module
